import $ from 'jquery';

/**
 * Lista količina.
 */
export default class QuantityList
{
    /**
     * Konstruktor.
     *
     * @param el
     */
    constructor(el)
    {
        this.$el = $(el);
        this.quantities = [];

        this.$el.find('.quantity-input').each(function(i, quantity) {
            this.quantities.push(quantity.ep);
            $(quantity.ep).on('change', this.onChange.bind(this));
        }.bind(this));
    }

    /**
     * Da li je trenutna vrijednost ispravna.
     *
     * @returns {boolean}
     */
    get valid()
    {
        return this.value > 0;
    }

    /**
     * Trenutna vrijednost elementa.
     *
     * @returns {number}
     */
    get value()
    {
        let value = 0;

        $.each(this.quantities, function(i, quantity) {
            value += quantity.value;
        });

        return value;
    }

    get values()
    {
        let values = {};

        $.each(this.quantities, function(i, quantity) {
            if (quantity.value > 0) {
                values[parseInt(quantity.input.$el.data('product-id'))] = quantity.value;
            }
        });

        return values;
    }

    /**
     * Kada se promijeni vrijednost nekog od elemenata.
     */
    onChange()
    {
        $(this).trigger('change');
    }

    /**
     * Resetira polja na nule.
     */
    reset()
    {
        $.each(this.quantities, function(i, quantity) {
            quantity.reset();
        });
    }
}