<?php
namespace Ep\Woo\Form\View\Helper;

use Ep\Form\View\Helper\AbstractFormHelper;
use Ep\Woo\Form\Element\Attribute as AttributeElement;

/**
 * Renderira Attribute element.
 *
 * @package Ep\Woo\Form\View\Helper
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-woocommerce
 */
class Attribute extends AbstractFormHelper
{
    /**
     * @param AttributeElement $element
     *
     * @return string
     */
    public function __invoke(AttributeElement $element)
    {
        $label = $element->getLabelAttributes();
        $label['class'] = ($label['class'] ?? '') . ' product-attribute__label';
        $element->setLabelAttributes($label);

        $class = $element->getAttribute('class') ?? '';
        $element->setAttribute('class', 'product-attribute__input ' . $class);

        if (!$element->getAttribute('id')) {
            $element->setAttribute('id', $this->generateId('attr_'));
        }

        return $this->getView()->render('@woo/form/element/attribute.html.twig', [
            'attribute' => $element,
        ]);
    }
}